var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTimes } from 'react-icons/fa';
var Filter = function (_a) {
    var parameters = _a.parameters, onApply = _a.onApply, onClose = _a.onClose, initialFilters = _a.initialFilters;
    var _b = React.useState({}), filterValues = _b[0], setFilterValues = _b[1];
    var _c = React.useState({}), errors = _c[0], setErrors = _c[1];
    var validateField = function (parameter, value) {
        var _a;
        if (!value) {
            if ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) {
                return 'Trường này là bắt buộc';
            }
            return '';
        }
        var numValue = Number(value);
        if (parameter.data_type === 'integer' || parameter.data_type === 'double') {
            if (isNaN(numValue)) {
                return 'Giá trị không hợp lệ';
            }
            var validation = __assign({}, parameter.validation);
            if (validation.gte)
                if (validation.gte !== undefined && numValue < validation.gte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.gte);
                }
            if (validation.gt)
                if (validation.gt !== undefined && numValue <= validation.gt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i l\u1EDBn h\u01A1n ".concat(validation.gt);
                }
            if (validation.lt)
                if (validation.lt !== undefined && numValue >= validation.lt) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ".concat(validation.lt);
                }
            if (validation.lte)
                if (validation.lte !== undefined && numValue > validation.lte) {
                    return "Gi\u00E1 tr\u1ECB ph\u1EA3i nh\u1ECF h\u01A1n ho\u1EB7c b\u1EB1ng ".concat(validation.lte);
                }
        }
        return '';
    };
    var hasEmptyRequiredFields = function () {
        return parameters.some(function (parameter) {
            var _a;
            return ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) &&
                (filterValues[parameter.code] === undefined ||
                    filterValues[parameter.code] === '' ||
                    filterValues[parameter.code] === null);
        });
    };
    var handleInputChange = function (code, value, dataType) {
        var _a, _b, _c, _d;
        var parsedValue = value;
        switch (dataType) {
            case 'integer':
                parsedValue = typeof value === 'string' ? parseInt(value) : value ? 1 : 0;
                break;
            case 'double':
                parsedValue = typeof value === 'string' ? parseFloat(value) : value ? 1 : 0;
                break;
            case 'boolean':
                parsedValue = Boolean(value);
                break;
            case 'datetime':
            case 'date':
                if (typeof value === 'string') {
                    var match = value.match(/^(\d{1,4})-(\d{2})-(\d{2})(T(\d{2}):(\d{2})(:(\d{2})(.(\d{1,3}))?)?)?$/);
                    if (match)
                        parsedValue = new Date(Number(match[1]), Number(match[2]) - 1, Number(match[3]), Number((_a = match[5]) !== null && _a !== void 0 ? _a : 0), Number((_b = match[6]) !== null && _b !== void 0 ? _b : 0), Number((_c = match[8]) !== null && _c !== void 0 ? _c : 0), Number((_d = match[10]) !== null && _d !== void 0 ? _d : 0)).toISOString();
                }
                break;
        }
        setFilterValues(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = parsedValue, _a)));
        });
        setErrors(function (prev) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[code] = '', _a)));
        });
    };
    var handleApply = function () {
        var newErrors = {};
        var hasErrors = false;
        parameters.forEach(function (parameter) {
            var error = validateField(parameter, filterValues[parameter.code]);
            if (error) {
                newErrors[parameter.code] = error;
                hasErrors = true;
            }
        });
        setErrors(newErrors);
        if (!hasErrors) {
            onApply(filterValues);
        }
    };
    var convertValueParameter = function (value) {
        if (!value)
            return '';
        var now = new Date();
        if (value === '$$year')
            return now.getFullYear().toString();
        if (value === '$$month')
            return (now.getMonth() + 1).toString();
        if (value === '$$day')
            return now.getDate().toString();
        var regex = /^\$\$(today|now)([+-])?(\d+)?(days|months|years|weeks|hours|minutes|seconds|milliseconds)?$/;
        var match = value.match(regex);
        if (!match)
            return value;
        var base = match[1], operator = match[2], amountStr = match[3], unit = match[4];
        var offset = amountStr ? parseInt(amountStr) * (operator === '-' ? -1 : 1) : 0;
        var dt = new Date();
        if (base === 'today') {
            dt.setHours(0, 0, 0, 0);
        }
        if (unit) {
            switch (unit) {
                case 'days':
                    dt.setDate(dt.getDate() + offset);
                    break;
                case 'weeks':
                    dt.setDate(dt.getDate() + offset * 7);
                    break;
                case 'months':
                    dt.setMonth(dt.getMonth() + offset);
                    break;
                case 'years':
                    dt.setFullYear(dt.getFullYear() + offset);
                    break;
                case 'hours':
                    dt.setHours(dt.getHours() + offset);
                    break;
                case 'minutes':
                    dt.setMinutes(dt.getMinutes() + offset);
                    break;
                case 'seconds':
                    dt.setSeconds(dt.getSeconds() + offset);
                    break;
                case 'milliseconds':
                    dt.setMilliseconds(dt.getMilliseconds() + offset);
                    break;
            }
        }
        return dt.toISOString();
    };
    var renderInput = function (parameter) {
        var value = parameter.code
            ? filterValues[parameter.code] !== undefined
                ? filterValues[parameter.code]
                : convertValueParameter(parameter.default) || ''
            : '';
        var error = parameter.code ? errors[parameter.code] : '';
        var inputPropsClass = {
            className: "filter-input ".concat(error ? 'filter-input--error' : ''),
            'aria-invalid': !!error,
        };
        var renderField = function () {
            var formatDate = function (val) {
                var dt = new Date(val);
                var year = dt.getFullYear();
                var month = "".concat(dt.getMonth() + 1).padStart(2, '0');
                var day = "".concat(dt.getDate()).padStart(2, '0');
                return "".concat(year, "-").concat(month, "-").concat(day);
            };
            switch (parameter.input_type) {
                case 'number':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "number", value: Number(value), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'checkbox':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "checkbox", checked: !!value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.checked, parameter.data_type);
                            } })) }));
                case 'date':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "date", value: formatDate(value), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'datetime':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "datetime-local", value: formatDate(value), onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
                case 'dropdown':
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("select", __assign({}, inputPropsClass, { value: value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            }, children: _jsx("option", { value: "", children: "Select..." }) })) }));
                default:
                    return (_jsx("div", { className: "filter-input-wrapper", style: { position: 'relative' }, children: _jsx("input", __assign({}, inputPropsClass, { type: "text", value: value, onChange: function (e) {
                                return handleInputChange(parameter.code, e.target.value, parameter.data_type);
                            } })) }));
            }
        };
        return (_jsxs("div", { className: "filter-input-item", children: [renderField(), error && _jsx("p", { className: "filter-error", children: error })] }));
    };
    return (_jsx("div", { className: "filter-overlay", children: _jsxs("div", { className: "filter-modal", children: [_jsxs("div", { className: "filter-modal__header", style: { display: 'flex', justifyContent: 'space-between', alignItems: 'center' }, children: [_jsx("p", { className: "filter-modal__header--text", children: "L\u1ECDc d\u1EEF li\u1EC7u" }), _jsx("button", { className: "filter-modal__header--btn-close", disabled: hasEmptyRequiredFields(), onClick: onClose, children: _jsx(FaTimes, { size: 30, style: { display: 'block' } }) })] }), _jsx("div", { className: "filter-content", children: (parameters === null || parameters === void 0 ? void 0 : parameters.length) > 0 &&
                        parameters.map(function (parameter) {
                            var _a;
                            return (_jsxs("div", { className: "filter-item", children: [_jsxs("label", { children: [parameter.label || parameter.code, ((_a = parameter.validation) === null || _a === void 0 ? void 0 : _a.required) && _jsx("span", { className: "required", children: "*" })] }), renderInput(parameter)] }, parameter.code));
                        }) }), _jsx("div", { className: "filter-actions", children: _jsx("button", { className: "btn btn__primary filter-actions__accept", onClick: handleApply, children: "L\u1ECDc d\u1EEF li\u1EC7u" }) })] }) }));
};
export default Filter;
